//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "CpkKeyWins2.h"
#include "Cyberpunk.h"
#include "Mixmaster.h"
#include "WipeDlgs.h"
#include "HelpDlgs.h"
#include "FileMan.h"
#include "FileWin.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma link "KeyringWins"
#pragma resource "*.dfm"
TCpkKeyWin2 *CpkKeyWin2;
//---------------------------------------------------------------------------
// TCpkKey
//---------------------------------------------------------------------------
__fastcall TCpkKey2::TCpkKey2()
  : TCustomKey()
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKey2::TCpkKey2(TCustomKey *key)
  : TCustomKey(key)
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKey2::TCpkKey2(TStrings *key, bool Enabled)
  : TCustomKey(key)
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKey2::Algo()
{
   return (Count>0?GetToken(4,Strings[0]," "):s(""));
}
//---------------------------------------------------------------------------
// TCpkKeyList
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::TCpkKeyList2()
   : TCustomKeyList()
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::TCpkKeyList2(AnsiString filename)
   : TCustomKeyList(filename)
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::TCpkKeyList2(TCustomKeyList *keys)
   : TCustomKeyList(keys)
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::TCpkKeyList2(TCustomKey *key)
   : TCustomKeyList(key)
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::TCpkKeyList2(TStrings *keys)
   : TCustomKeyList(keys)
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::~TCpkKeyList2()
{
   //delete type2;
}
//---------------------------------------------------------------------------
/*void __fastcall TCpkKeyList2::GetType2()
{
   if (!type2) type2 = new TStringList();
   MixGetType2(type2);
}*/
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList2::SaveToFileBak(AnsiString &docname, int bakcopies)
{
   //TStringList *newtype2 = new TStringList();
   //newtype2->Sorted = true;
   TCpkKey2 *key;
   TStringList *keys = new TStringList();
   for (int i=0; i<Count; i++)
   {
      key = Key(i);
      if (!key || key->Count<15) continue;
      keys->Add(key->Text);
      //newtype2->Add((key->enabled?"":"#")+PadRight(key->name,shrtLen)+" "+key->address+" "+
      //   key->keyid+" "+key->version+" "+key->caps);
   }
   //::SaveToFileBak(newtype2,mtyp2txt,bakcopies);
   ::SaveToFileBak(keys,cringtxt,bakcopies);
   modified = false;
   //delete newtype2;
   delete keys;
   //GetType2();
}
//---------------------------------------------------------------------------
TCpkKey2* __fastcall TCpkKeyList2::Key(int atPos)
{
   if (atPos<0 || atPos>=Count) return NULL;
   return (TCpkKey2*)Objects[atPos];
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyList2::AddKeys(TCustomKeyList *keys)
{
   return TCustomKeyList::AddKeys(keys);
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyList2::AddKeys(TStrings *keys)
{
   int c=0;
   AnsiString desc;
   TStringList *key=new TStringList();
   TStringList *KEYS=new TStringList();
   KEYS->AddStrings(keys);
   while (CpkGetNextKey(desc,key,KEYS))
   {
      AddKey(key);
      c++;
   }
   delete KEYS;
   delete key;
   return c;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList2::LoadFromStrings(TStrings *keys)
{
   Clear(); AddKeys(keys);
   modified = false;
}
//---------------------------------------------------------------------------
bool __fastcall TCpkKeyList2::AddKey(TStrings *key)
{
   if (!CpkKeyDefinately(key)) return false;
   TCpkKey2 *KEY = new TCpkKey2(key);
   AddKey(KEY);
   delete KEY;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TCpkKeyList2::AddKey(TCustomKey *key)
{
   if (!CpkKeyDefinately(key)) return false;

   bool enabled;
   TCpkKey2 *KEY = new TCpkKey2(key);

   //if (!type2) GetType2();
   //if (InType2(KEY,enabled)) KEY->enabled = enabled;
   //else type2->Add((KEY->enabled?"":"#")+KEY->Strings[0]);

   AnsiString shrt=KEY->name,addr=KEY->address;//,vers=KEY->version;
   AddObject(shrt+","+addr+","+KEY->keyid+","+KEY->algo,KEY);
   if (shrt.Length()>shrtLen) shrtLen = shrt.Length();
   if (addr.Length()>addrLen) addrLen = addr.Length();
   modified = true;
   return true;
}
//---------------------------------------------------------------------------
/*bool __fastcall TCpkKeyList2::InType2(TCpkKey2 *key, bool &enabled)
{
   AnsiString keydesc = key->Strings[0];
   if((enabled=type2->IndexOf("#"+keydesc)<0)==true)
      return type2->IndexOf(keydesc)>=0;
   return true;
}*/
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKeyList2::KeyDescription(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   addrLen = 31;
   AnsiString desc,addr;
   TStringList *flds = new TStringList();
   flds->CommaText = Strings[atPos];

   addr = PadRight(flds->Strings[1],addrLen);
   if (addr[addrLen]!=' ') addr = addr.SubString(1,addrLen-3)+"...";

   desc = PadRight(flds->Strings[0],shrtLen)+"  "+addr+"  "+flds->Strings[2]+"  "+
      flds->Strings[3]+"  "+flds->Strings[4];
   delete flds;
   return desc;
}
//---------------------------------------------------------------------------
// TCpkKeyWin
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin2::TCpkKeyWin2(TComponent* Owner)
	: TCustomKeyWin(Owner)
{
   keyringname = "Cypherpunk";
   hidedisabled = GetAppIni(CpkHideDisabled,"0")=="1";
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);
   keys = new TCpkKeyList2();
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin2::TCpkKeyWin2(TComponent* Owner, TCpkKeyList2 *Imports)
	: TCustomKeyWin(Owner)
{
   imports = Imports;
   keyringname = "Cypherpunk";
   hidedisabled = GetAppIni(CpkHideDisabled,"0")=="1";
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);
   keys = new TCpkKeyList2();
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin2::~TCpkKeyWin2()
{
   CpkKeyWin2 = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::SaveKeys()
{
   if (!keys->Count)
   {
      if (FileExists(cringtxt)) zapfile(cringtxt,1);
      return;
   }
   AnsiString cap = Caption;
   Caption = "Saving..."; AppProcessMessages(); Sleep(200);
   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   keys->SaveToFileBak(mringtxt,STATSBAKCOPIES);
   newkeys->Clear();
   SetRedraw(TreeView,0);
   LoadTreeViewQuiet();
   AppProcessMessages();
   SetRedraw(TreeView,1);
   Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::LoadKeys()
{
   initdone = true;
   if (FileExists(cringtxt)) keys->LoadFromFile(cringtxt);
   if (imports && imports->Count) AddKeysImport(imports);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::LoadTreeView()
{
   TTreeNode *node,*cnode;

   ClearTree();
   TStringList *next=new TStringList();
   TreeView->Items->BeginUpdate();
   for (int i=0; i<keys->Count; i++)
   {
      TCpkKey2 *KEY = ((TCpkKeyList2*)keys)->Key(i);
      if (newkeys->IndexOf(keys->Strings[i])<0 && hidedisabled && !KEY->enabled) continue;

      AnsiString keydesc = keys->KeyDescription(i);
      node = TreeView->Items->AddChildObject(TreeView->Selected,keydesc,KEY);

      node->ImageIndex = KEY->enabled ? 0:1;
      node->SelectedIndex = node->ImageIndex;

      if (newkeys->IndexOf(keys->Strings[i])>=0) SetTreeItemBold(node,true,TreeView);
      keynodes->Add(node);

      keydesc = KEY->Strings[0];
      cnode=TreeView->Items->AddChild(node,"Name    : "+GetParam(0,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Address : "+GetParam(1,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Key-Id  : "+GetParam(2,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Version : "+GetParam(3,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Caps    : "+GetParam(4,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   AppProcessMessages();
   delete next;
}
//---------------------------------------------------------------------------
TCpkKey2* __fastcall TCpkKeyWin2::NodeKey(int atPos)
{
   if (atPos<0 || atPos>=keynodes->Count) return NULL;
   TCpkKey2 *key = (TCpkKey2*)((TTreeNode*)keynodes->Items[atPos])->Data;
   return key;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::AddKeysImport(TCustomKeyList *NewKeys)
{
   while (!initdone) AppProcessMessages(); // may not be init yet
   newkeys->Text = NewKeys->Text;
   keys->AddKeys(NewKeys);
   ClearAllBtn->Enabled = keys->Count>0 ? true:false;
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   //if (hidedisabled) HideDisBtn->Click();
   //else
   LoadTreeView();
   SetNothingSelected();
   AppProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::ImportBtnClick(TObject *Sender)
{
   AnsiString ImportDir,orgDir;
   TCpkKeyList2 *impkeys = new TCpkKeyList2();
   TCpkKeyList2 *dupkeys = new TCpkKeyList2();
   ImportDir = orgDir = GetAppIni(CpkImportDir,MixDir());
   /*if (ImportCypherpunkKeys(this,(TCpkKeyList2*)keys,impkeys,dupkeys,ImportDir))
   {
      if (impkeys->Count)
      {
         Sleep(100);
         BringToFront();
         AppProcessMessages();
         AddKeysImport(impkeys);
      }
      if (dupkeys->Count && this==CpkKeyWin2)
      {
         //if (!MixProbWin2) MixProbWin2 = new TMixProbWin2(AppMainForm);//,false);
         //MixProbWin2->BringToFront(); AppProcessMessages();
         //MixProbWin2->AddKeysImport(dupkeys);
      }
   }*/
   if (ImportDir!=orgDir)
      PutAppIni(CpkImportDir,ImportDir);
   delete dupkeys;
   delete impkeys;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::RemailerDocItemClick(TObject *Sender)
{
   AnsiString doc; int d;
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      doc = MixDir()+item->Caption;
      while ((d=doc.Pos("&"))>0) doc.Delete(d,1);
      if (FileExists(doc)) EditTextFile(doc);
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::HelpBtnClick(TObject *Sender)
{
   OpenHelp(
      "CypherpunkKeys\nCypherpunkKeysImp\nCypherpunkKeysDup\nRemailerConfig",
      "Cypherpunk Key Manager",
      "Cypherpunk Keyring Manager"
   );
}
//---------------------------------------------------------------------------
